/*
 This file is part of the digitalSTROM ds485-core library.

 Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland

 digitalSTROM ds485-core library is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation version 2
 of the License.

 digitalSTROM ds485-core library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with digitalSTROM ds485-core library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef CALLQUEUE_H_
#define CALLQUEUE_H_

#include "qp_port.h"
#include "qf.h"
#include "semaphore.h"

typedef struct{
    QEQueue     queue;
    sem_t       sem;
} CcInst_t;

typedef struct {
    QEvent super;
    QEQueue *requester;
    sem_t   *sem;
} DS485_QueueRequestEvt;

int ccCreate( CcInst_t *inst, QEvent const *sto[], int stoLen );
int ccFree( CcInst_t *inst );
QEvent* ccPostRequest( CcInst_t *inst, int signal );
void ccSendResponse( const QEvent* req, QEvent* res );
const QEvent* ccWaitResponse( CcInst_t *inst );

#endif /* CALLQUEUE_H_ */
